/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model


import canary.users.model.tables.*
import cc.cinnamon.canary.users.model.tables.*
import org.jooq.ForeignKey
import org.jooq.Identity
import org.jooq.Record
import org.jooq.UniqueKey
import org.jooq.impl.AbstractKeys

import javax.annotation.Generated


/**
 * A class modelling foreign key relationships between tables of the `public`
 * schema
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
object Keys {

    // -------------------------------------------------------------------------
    // IDENTITY definitions
    // -------------------------------------------------------------------------

    val IDENTITY_PERMISSIONS = Identities0.IDENTITY_PERMISSIONS
    val IDENTITY_ROLES = Identities0.IDENTITY_ROLES
    val IDENTITY_ROLES_PERMISSIONS = Identities0.IDENTITY_ROLES_PERMISSIONS
    val IDENTITY_USERS = Identities0.IDENTITY_USERS
    val IDENTITY_USERS_ROLES = Identities0.IDENTITY_USERS_ROLES

    // -------------------------------------------------------------------------
    // UNIQUE and PRIMARY KEY definitions
    // -------------------------------------------------------------------------

    val PERMISSIONS_PKEY = UniqueKeys0.PERMISSIONS_PKEY
    val ROLES_PKEY = UniqueKeys0.ROLES_PKEY
    val ROLES_PERMISSIONS_PKEY = UniqueKeys0.ROLES_PERMISSIONS_PKEY
    val USERS_PKEY = UniqueKeys0.USERS_PKEY
    val USERS_ROLES_PKEY = UniqueKeys0.USERS_ROLES_PKEY

    // -------------------------------------------------------------------------
    // FOREIGN KEY definitions
    // -------------------------------------------------------------------------

    val ROLES_PERMISSIONS__ROLES_PERMISSIONS_ROLE_ID_FKEY = ForeignKeys0.ROLES_PERMISSIONS__ROLES_PERMISSIONS_ROLE_ID_FKEY
    val ROLES_PERMISSIONS__ROLES_PERMISSIONS_PERMISSION_ID_FKEY = ForeignKeys0.ROLES_PERMISSIONS__ROLES_PERMISSIONS_PERMISSION_ID_FKEY
    val USERS_ROLES__USERS_ROLES_USER_ID_FKEY = ForeignKeys0.USERS_ROLES__USERS_ROLES_USER_ID_FKEY
    val USERS_ROLES__USERS_ROLES_ROLE_ID_FKEY = ForeignKeys0.USERS_ROLES__USERS_ROLES_ROLE_ID_FKEY

    // -------------------------------------------------------------------------
    // [#1459] distribute members to avoid static initialisers > 64kb
    // -------------------------------------------------------------------------

    private class Identities0 : AbstractKeys() {
        companion object {
            var IDENTITY_PERMISSIONS = AbstractKeys.createIdentity(Permissions.PERMISSIONS, Permissions.PERMISSIONS.ID)
            var IDENTITY_ROLES = AbstractKeys.createIdentity(Roles.ROLES, Roles.ROLES.ID)
            var IDENTITY_ROLES_PERMISSIONS = AbstractKeys.createIdentity(RolesPermissions.ROLES_PERMISSIONS, RolesPermissions.ROLES_PERMISSIONS.ID)
            var IDENTITY_USERS = AbstractKeys.createIdentity(Users.USERS, Users.USERS.ID)
            var IDENTITY_USERS_ROLES = AbstractKeys.createIdentity(UsersRoles.USERS_ROLES, UsersRoles.USERS_ROLES.ID)
        }
    }

    private class UniqueKeys0 : AbstractKeys() {
        companion object {
            val PERMISSIONS_PKEY = AbstractKeys.createUniqueKey(Permissions.PERMISSIONS, "permissions_pkey", Permissions.PERMISSIONS.ID)
            val ROLES_PKEY = AbstractKeys.createUniqueKey(Roles.ROLES, "roles_pkey", Roles.ROLES.ID)
            val ROLES_PERMISSIONS_PKEY = AbstractKeys.createUniqueKey(RolesPermissions.ROLES_PERMISSIONS, "roles_permissions_pkey", RolesPermissions.ROLES_PERMISSIONS.ID)
            val USERS_PKEY = AbstractKeys.createUniqueKey(Users.USERS, "users_pkey", Users.USERS.ID)
            val USERS_ROLES_PKEY = AbstractKeys.createUniqueKey(UsersRoles.USERS_ROLES, "users_roles_pkey", UsersRoles.USERS_ROLES.ID)
        }
    }

    private class ForeignKeys0 : AbstractKeys() {
        companion object {
            val ROLES_PERMISSIONS__ROLES_PERMISSIONS_ROLE_ID_FKEY = AbstractKeys.createForeignKey(Keys.ROLES_PKEY, RolesPermissions.ROLES_PERMISSIONS, "roles_permissions__roles_permissions_role_id_fkey", RolesPermissions.ROLES_PERMISSIONS.ROLE_ID)
            val ROLES_PERMISSIONS__ROLES_PERMISSIONS_PERMISSION_ID_FKEY = AbstractKeys.createForeignKey(Keys.PERMISSIONS_PKEY, RolesPermissions.ROLES_PERMISSIONS, "roles_permissions__roles_permissions_permission_id_fkey", RolesPermissions.ROLES_PERMISSIONS.PERMISSION_ID)
            val USERS_ROLES__USERS_ROLES_USER_ID_FKEY = AbstractKeys.createForeignKey(Keys.USERS_PKEY, UsersRoles.USERS_ROLES, "users_roles__users_roles_user_id_fkey", UsersRoles.USERS_ROLES.USER_ID)
            val USERS_ROLES__USERS_ROLES_ROLE_ID_FKEY = AbstractKeys.createForeignKey(Keys.ROLES_PKEY, UsersRoles.USERS_ROLES, "users_roles__users_roles_role_id_fkey", UsersRoles.USERS_ROLES.ROLE_ID)
        }
    }
}
